#region License Information
/* HeuristicLab
 * Copyright (C) 2002-2014 Heuristic and Evolutionary Algorithms Laboratory (HEAL)
 *
 * This file is part of HeuristicLab.
 *
 * HeuristicLab is free software: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 *
 * HeuristicLab is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with HeuristicLab. If not, see <http://www.gnu.org/licenses/>.
 */
#endregion

using HeuristicLab.Common;
using System;
using System.Threading;

namespace HeuristicLab.Core.Networks {
  [Item("MyProgrammableNode", "A programmable node of a network.")]
  public class MyProgrammableNode : ProgrammableNode.CompiledProgrammableNode {
    protected MyProgrammableNode(MyProgrammableNode original, Cloner cloner) : base(original, cloner) { }
    protected MyProgrammableNode(ProgrammableNode context) : base(context) { }

    public override IDeepCloneable Clone(Cloner cloner) {
      return new MyProgrammableNode(this, cloner);
    }

    protected override void MessagePort_MessageReceived(object sender, EventArgs<IMessage, CancellationToken> e) {
      // implement processing of messages here
    }
  }
}
